local DB = QuestCheckerDB
local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", function(self, event, ...) QC_OnEvent(self, event, ...) end)
local isInit = false
local isAddOnLoaded = false

function QC_OnInitialize()
    --create Options categories
    ----Main Panel
    local optPan = CreateFrame("Frame", "QuestCheckerOptions", UIParent)
    optPan.name = "QuestChecker"
    InterfaceOptions_AddCategory(optPan)
    local fsMainTitle = optPan:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    fsMainTitle:SetPoint("TOPLEFT", 12, -16)
    fsMainTitle:SetText("QuestChecker - About")
    QC_generalTextFilling(optPan)

    ----Child Panel
    local childPan = CreateFrame("Frame", "QuestCheckerOptionsChild", optPan)
    childPan.name = "Checker"
    childPan.parent = optPan.name
    InterfaceOptions_AddCategory(childPan)
    local fsOptTitle = childPan:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
    fsOptTitle:SetPoint("TOPLEFT", 12, -16)
    fsOptTitle:SetText("QuestChecker")
------------------------------------------------------------------------------------------------
    ----Quest Checker Box Frame
    local f1 = CreateFrame("Frame", nil, childPan, BackdropTemplateMixin and "BackdropTemplate")
    f1:SetHeight(75)
    f1:SetWidth(InterfaceOptionsFrame:GetWidth() - (InterfaceOptionsFrame:GetWidth() / 3))
    --print(InterfaceOptionsFrame:GetWidth())
    f1:SetPoint("TOPLEFT", 25, -48)
    f1:SetMovable(false)
    f1:SetBackdrop({
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	edgeSize = 16,
	insets = { left = 4, right = 4, top = 4, bottom = 4 },
})

    f1:SetBackdropColor(0.5, 0.5, 0.5, .25)
    --Add edit box
    local box = CreateFrame("EditBox", "QuestCheckerBox", f1, "InputBoxTemplate")
    box:SetPoint("BOTTOMLEFT", 24, 24)
    box:SetHeight(10)
    box:SetWidth(150)
    box:SetAutoFocus(false)
    box:SetMaxLetters(20)
    box:SetScript("OnEnterPressed", function(self) QC_GetQuestsStatus(self) end)
    local fsEB = f1:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
    fsEB:SetPoint("TOPLEFT", 16, -16)
    fsEB:SetText("Provide the quest ID in the Box below")
    local b1 = CreateFrame("Button", "QuestCheckerBoxButton", f1, "UIPanelButtonTemplate")
    b1:SetHeight(20)
    b1:SetWidth(35)
    b1:SetPoint("LEFT", box, "RIGHT", 4, 0)
    b1:SetText("Ok")
    b1:SetScript("OnClick", function() QC_GetQuestsStatus(QuestCheckerBox) end)
------------------------------------------------------------------------------------------------
    ----Questline Checker Box Frame
    local f2 = CreateFrame("Frame", nil, childPan, BackdropTemplateMixin and "BackdropTemplate")
    f2:SetHeight(75)
    f2:SetWidth(InterfaceOptionsFrame:GetWidth() - (InterfaceOptionsFrame:GetWidth() / 3))
    --print(InterfaceOptionsFrame:GetWidth())
    f2:SetPoint("TOPLEFT", 25, -136)
    f2:SetMovable(false)
    f2:SetBackdrop({
	bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
	edgeSize = 16,
	insets = { left = 4, right = 4, top = 4, bottom = 4 },
})

    f2:SetBackdropColor(0.5, 0.5, 0.5, .25)
    --Add edit box
    local box2 = CreateFrame("EditBox", "QuestCheckerLineBox", f2, "InputBoxTemplate")
    box2:SetPoint("BOTTOMLEFT", 24, 24)
    box2:SetHeight(10)
    box2:SetWidth(150)
    box2:SetAutoFocus(false)
    box2:SetMaxLetters(20)
    box2:SetScript("OnEnterPressed", function(self) QC_GetQuestLineStatus(self) end)
    local fsEB2 = f2:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
    fsEB2:SetPoint("TOPLEFT", 16, -16)
    fsEB2:SetText("Provide the questline ID in the Box below")
    local b2 = CreateFrame("Button", "QuestCheckerLineBoxButton", box2, "UIPanelButtonTemplate")
    b2:SetHeight(20)
    b2:SetWidth(35)
    b2:SetPoint("LEFT", box2, "RIGHT", 4, 0)
    b2:SetText("Ok")
    b2:SetScript("OnClick", function() QC_GetQuestLineStatus(QuestCheckerLineBox) end)

----------------------------------------------------------------------------------------------
    SLASH_QUESTCHECKER1 = "/qc"
    SLASH_QUESTCHECKER2 = "/questchecker"
    SlashCmdList["QUESTCHECKER"] = function(msg) QC_ChatCommands(msg) end
    isInit = true
end

function QC_ChatCommands(msg)
    msg = string.lower(msg)
	local args = {}
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word)
	end
    if not args[1] then
        --need to call the function twice because of Blizzard (no idea why)
        InterfaceOptionsFrame_OpenToCategory(QuestCheckerOptions)
        InterfaceOptionsFrame_OpenToCategory(QuestCheckerOptions)
    else
        return
    end
end

function QC_OnEvent(self, event, ...)
    if event == "PLAYER_LOGIN" and isInit == false then
        QC_OnInitialize()
    elseif event == "ADDON_LOADED" and isInit and isAddOnLoaded == false then
        print(QC_colorPrefix("Loading complete !", "green"))
        isAddOnLoaded = true
    end
end

function QC_colorPrefix(text, color)
    local t = ""
    if color == "red" then
        t = "|cffff0000QuestChecker|r - "..text
    elseif color == "green" then
        t = "|cff00ff00QuestChecker|r - "..text
    elseif color == "blue" then
        t = "|cff0000ffQuestChecker|r - "..text
    else
        t = "|cffffffffQuestChecker|r - "..text
    end
    return t
end

function QC_generalTextFilling(panel)
    local fsDesc = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    fsDesc:SetPoint("TOPLEFT", 12, -48)
    fsDesc:SetText("QuestChecker let you know if you have completed a quest or not.")
    local fsDesc2 = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    fsDesc2:SetPoint("TOPLEFT", 12, -60)
    fsDesc2:SetText("All you need to do is providing the quest ID in the options edit box.")
    local fsDesc3 = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    fsDesc3:SetPoint("TOPLEFT", 12, -72)
    fsDesc3:SetText("The result will be shown in the default chat frame")
    local fsDesc4 = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    fsDesc4:SetPoint("TOPLEFT", 12, -96)
    fsDesc4:SetText("You can also follow questlines status by providing questline ID")
    local fsDesc5 = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
    fsDesc5:SetPoint("TOPLEFT", 12, -108)
    fsDesc5:SetText("All ID's can be found on wowhead.com")
    local fsAuthor = panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    fsAuthor:SetPoint("TOPLEFT", 12, -132)
    fsAuthor:SetText("Authors: |cffffffff"..GetAddOnMetadata("QuestChecker", "Author").."|r")
    local fsVer = panel:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    fsVer:SetPoint("TOPLEFT", 12, -148)
    fsVer:SetText("Version: |cffffffff"..GetAddOnMetadata("QuestChecker", "Version").."|r")
end

function QC_GetQuestsStatus(self)
    local questID = self:GetText()
    if questID == "" or questID == nil then return end
    self:SetText("")
    if strmatch(questID, "%d") then
        if tonumber(questID) ~= nil and tonumber(questID) > -2147483648 and tonumber(questID) < 2147483647 then
            local title = C_QuestLog.GetTitleForQuestID(questID)
            if not title then title = "*Unknow Title Quest*" end
            local isCompleted = C_QuestLog.IsQuestFlaggedCompleted(questID)
            if isCompleted then
                print(QC_colorPrefix(title.." is |cff00ff00Completed|r !", "green"))
            else
                print(QC_colorPrefix(title.." is |cffff0000not Completed|r !", "green"))
            end
        else
            print(QC_colorPrefix("QuestID must be a number value between -2147483648 and 2147483647", "red"))
        end
    else
        print(QC_colorPrefix("QuestID "..questID.." must be numeric !", "red"))
    end
end

function QC_GetQuestLineStatus(self)
    local questLineID = self:GetText()
    if questLineID == "" or questLineID == nil then return end
    self:SetText("")
    if strmatch(questLineID, "%d") then
        if tonumber(questLineID) and tonumber(questLineID) > -2147483648 and tonumber(questLineID) < 2147483647 then
            local quests = C_QuestLine.GetQuestLineQuests(questLineID)
            if next(quests) == nil or quests == nil then print(QC_colorPrefix("QuestLineID "..questLineID.." not found !", "red")); return end
            if C_QuestLine.IsComplete(questLineID) then
                print(QC_colorPrefix("Questline already completed !", "green"))
            else
                print(QC_colorPrefix("Current quests status for questLine with ID "..questLineID..":", "blue"))
                local title = ""
                for quest_k, quest_v in ipairs(quests) do
                    if C_QuestLog.IsQuestFlaggedCompleted(quest_v) ~= true then
                        title = C_QuestLog.GetTitleForQuestID(quest_v)
                        if not title then title = "*Unknow Title Quest*" end
                        print(QC_colorPrefix(tostring(title).." |cffff0000not completed|r (ID: "..tostring(quest_v)..")", "red"))
                    else
                        title = C_QuestLog.GetTitleForQuestID(quest_v)
                        if not title then title = "*Unknow Title Quest*" end
                        print(QC_colorPrefix(tostring(title).." |cff00ff00completed|r (ID: "..tostring(quest_v)..")", "green"))
                    end
                end
            end
        else
            print(QC_colorPrefix("QuestLineID must be a number value between -2147483648 and 2147483647", "red"))
        end
    else
        print(QC_colorPrefix("QuestLineID "..questLineID.." must be numeric !", "red"))
    end
end
